/* OSLib---efficient, type-safe, transparent, extensible,
 * register-safe API coverage of RISC OS
 * 
 * Copyright (c) 1994-2012 Jonathan Coxhead and OSLib maintainers
 * 
 * Licence:
 * 
 *    OSLib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version - and this with the following clarification and
 * special exception:
 * 
 *    Linking this library statically or dynamically with other modules
 * is making a combined work based on this library. Thus, the terms
 * and conditions of the GNU General Public License cover the whole
 * combination.
 * 
 *    As a special exception, the copyright holders of this library
 * give you permission to link this library with independent modules
 * to produce an executable, regardless of the license terms of these
 * independent modules, and to copy and distribute the resulting
 * executable under terms of your choice, provided that you also meet,
 * for each linked independent module, the terms and conditions of the
 * license of that module. An independent module is a module which is
 * not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library,
 * but you are not obliged to do so. If you do not wish to do so, delete
 * this exception statement from your version.
 * 
 *    OSLib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License
 * along with this programme; if not, write to the Free Software
 * Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using OSLib;
using OSLib.Toolbox;
using OSLib.Gadget;

[CCode (cheader_filename = "oslib/adjuster.h")]
namespace OSLib.Adjuster
{
  [CCode (cname = "adjuster_gadget")]
  public struct Gadget
  {
    [CCode (cname = "reserved")]
    public unowned int Reserved;
  }

  [CCode (cname = "adjuster_object")]
  public struct Object : OSLib.Gadget.ObjectBase
  {
    [CCode (cname = "reserved")]
    public unowned int Reserved;
  }

  [CCode (cname = "adjuster_action_clicked")]
  public struct ActionClicked
  {
    [CCode (cname = "up")]
    public unowned bool Up;
  }

  [CCode (cname = "adjuster_action_clicked_block")]
  public struct ActionClickedBlock : Toolbox.ActionHeaderBase
  {
    [CCode (cname = "up")]
    public unowned bool Up;
  }

  [CCode (cname="class_ADJUSTER")]
  public const Toolbox.Class Class_Adjuster;
  [CCode (cname="adjuster_INCREMENT")]
  public const OSLib.Gadget.Flags Increment;
  [CCode (cname="adjuster_VERTICAL")]
  public const OSLib.Gadget.Flags Vertical;
  [CCode (cname="action_ADJUSTER_CLICKED")]
  public const bits Action_AdjusterClicked;

}
