/* OSLib---efficient, type-safe, transparent, extensible,
 * register-safe API coverage of RISC OS
 * 
 * Copyright (c) 1994-2012 Jonathan Coxhead and OSLib maintainers
 * 
 * Licence:
 * 
 *    OSLib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version - and this with the following clarification and
 * special exception:
 * 
 *    Linking this library statically or dynamically with other modules
 * is making a combined work based on this library. Thus, the terms
 * and conditions of the GNU General Public License cover the whole
 * combination.
 * 
 *    As a special exception, the copyright holders of this library
 * give you permission to link this library with independent modules
 * to produce an executable, regardless of the license terms of these
 * independent modules, and to copy and distribute the resulting
 * executable under terms of your choice, provided that you also meet,
 * for each linked independent module, the terms and conditions of the
 * license of that module. An independent module is a module which is
 * not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library,
 * but you are not obliged to do so. If you do not wish to do so, delete
 * this exception statement from your version.
 * 
 *    OSLib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License
 * along with this programme; if not, write to the Free Software
 * Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using OSLib;
using OSLib.OS;

[CCode (cheader_filename = "oslib/convertpng.h")]
namespace OSLib.ConvertPNG
{
  [CCode (cname = "convertpng_info_flags")]
  public enum InfoFlags
  {
    Default = 0
  }

  [CCode (cname = "convertpng_create_sprite_flags")]
  public enum CreateSpriteFlags
  {
    [CCode (cname = "convertpng_CREATE_SPRITE_AREA")]
    CreateSpriteArea,
    [CCode (cname = "convertpng_USE_BACKGROUND")]
    UseBackground
  }

  [CCode (cname = "convertpng_colour_type")]
  public enum ColourType
  {
    [CCode (cname = "convertpng_HAS_PALETTE")]
    HasPalette,
    [CCode (cname = "convertpng_IS_COLOUR")]
    IsColour,
    [CCode (cname = "convertpng_HAS_ALPHA_CHANNEL")]
    HasAlphaChannel
  }

  [CCode (cname = "convertpng_interlace_type")]
  public enum InterlaceType
  {
    [CCode (cname = "convertpng_NO_INTERLACING")]
    NoInterlacing,
    [CCode (cname = "convertpng_ADAM7_INTERLACING")]
    Adam7Interlacing
  }


  [CCode (cname = "xconvertpng_info")]
  public static OS.Error* XInfo
    (InfoFlags flags,
     char* buffer,
     int size,
     out int width,
     out int height,
     out int bpp,
     out ColourType colour_type,
     out InterlaceType interlace_type);

  [CCode (cname = "convertpng_info")]
  public static void Info
    (InfoFlags flags,
     char* buffer,
     int size,
     out int width,
     out int height,
     out int bpp,
     out ColourType colour_type,
     out InterlaceType interlace_type);

  [CCode (cname = "xconvertpng_create_sprite")]
  public static OS.Error* XCreateSprite
    (CreateSpriteFlags flags,
     char* input_buffer,
     int input_size,
     char* output_buffer,
     int output_size,
     OS.Colour background,
     out int size);

  [CCode (cname = "convertpng_create_sprite")]
  public static int CreateSprite
    (CreateSpriteFlags flags,
     char* input_buffer,
     int input_size,
     char* output_buffer,
     int output_size,
     OS.Colour background);

}
