/* OSLib---efficient, type-safe, transparent, extensible,
 * register-safe API coverage of RISC OS
 * 
 * Copyright (c) 1994-2012 Jonathan Coxhead and OSLib maintainers
 * 
 * Licence:
 * 
 *    OSLib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version - and this with the following clarification and
 * special exception:
 * 
 *    Linking this library statically or dynamically with other modules
 * is making a combined work based on this library. Thus, the terms
 * and conditions of the GNU General Public License cover the whole
 * combination.
 * 
 *    As a special exception, the copyright holders of this library
 * give you permission to link this library with independent modules
 * to produce an executable, regardless of the license terms of these
 * independent modules, and to copy and distribute the resulting
 * executable under terms of your choice, provided that you also meet,
 * for each linked independent module, the terms and conditions of the
 * license of that module. An independent module is a module which is
 * not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library,
 * but you are not obliged to do so. If you do not wish to do so, delete
 * this exception statement from your version.
 * 
 *    OSLib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License
 * along with this programme; if not, write to the Free Software
 * Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using OSLib;
using OSLib.OS;

[CCode (cheader_filename = "oslib/debugger.h")]
namespace OSLib.Debugger
{
  [CCode (cname="error_DEBUG_BREAK_NOT_FOUND")]
  public const bits Error_DebugBreakNotFound;
  [CCode (cname="error_DEBUG_INVALID_VALUE")]
  public const bits Error_DebugInvalidValue;
  [CCode (cname="error_DEBUG_RESETTING")]
  public const bits Error_DebugResetting;
  [CCode (cname="error_DEBUG_NO_ROOM")]
  public const bits Error_DebugNoRoom;
  [CCode (cname="error_DEBUG_NO_BREAKPOINTS")]
  public const bits Error_DebugNoBreakpoints;
  [CCode (cname="error_DEBUG_BAD_BREAKPOINT")]
  public const bits Error_DebugBadBreakpoint;
  [CCode (cname="error_DEBUG_UNDEFINED")]
  public const bits Error_DebugUndefined;
  [CCode (cname="error_DEBUG_NON_ALIGNED")]
  public const bits Error_DebugNonAligned;
  [CCode (cname="error_DEBUG_NO_WORKSPACE")]
  public const bits Error_DebugNoWorkspace;

  [CCode (cname = "xdebugger_disassemble")]
  public static OS.Error* XDisassemble
    (int instruction,
     int* address,
     out string disassembly,
     out int used);

  [CCode (cname = "debugger_disassemble")]
  public static void Disassemble
    (int instruction,
     int* address,
     out string disassembly,
     out int used);

  [CCode (cname = "xdebugger_disassemble_thumb")]
  public static OS.Error* XDisassembleThumb
    (int instruction,
     int* address,
     out string disassembly,
     out int used);

  [CCode (cname = "debugger_disassemble_thumb")]
  public static void DisassembleThumb
    (int instruction,
     int* address,
     out string disassembly,
     out int used);

}
