/* OSLib---efficient, type-safe, transparent, extensible,
 * register-safe API coverage of RISC OS
 * 
 * Copyright (c) 1994-2012 Jonathan Coxhead and OSLib maintainers
 * 
 * Licence:
 * 
 *    OSLib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version - and this with the following clarification and
 * special exception:
 * 
 *    Linking this library statically or dynamically with other modules
 * is making a combined work based on this library. Thus, the terms
 * and conditions of the GNU General Public License cover the whole
 * combination.
 * 
 *    As a special exception, the copyright holders of this library
 * give you permission to link this library with independent modules
 * to produce an executable, regardless of the license terms of these
 * independent modules, and to copy and distribute the resulting
 * executable under terms of your choice, provided that you also meet,
 * for each linked independent module, the terms and conditions of the
 * license of that module. An independent module is a module which is
 * not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library,
 * but you are not obliged to do so. If you do not wish to do so, delete
 * this exception statement from your version.
 * 
 *    OSLib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License
 * along with this programme; if not, write to the Free Software
 * Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using OSLib;
using OSLib.OS;
using OSLib.Wimp;

[CCode (cheader_filename = "oslib/help.h")]
namespace OSLib.Help
{
  [CCode (cname = "help_flags")]
  public enum Flags
  {
    [CCode (cname = "help_DISABLE")]
    Disable,
    [CCode (cname = "help_READ_CONFIGURATION")]
    ReadConfiguration
  }

  [CCode (cname = "help_message_request")]
  public struct MessageRequest
  {
    [CCode (cname = "pos")]
    public unowned OS.Coord Pos;
    [CCode (cname = "buttons")]
    public unowned Wimp.MouseState Buttons;
    [CCode (cname = "w")]
    public unowned Wimp.W W;
    [CCode (cname = "i")]
    public unowned Wimp.I I;
  }

  [CCode (cname = "help_message_reply")]
  public struct MessageReply
  {
    [CCode (cname = "reply")]
    public unowned char Reply[236];
  }

  [CCode (cname = "help_message_enable")]
  public struct MessageEnable
  {
    [CCode (cname = "flags")]
    public unowned Flags Flags;
  }

  [CCode (cname = "help_full_message_request")]
  public struct FullMessageRequest : Wimp.MessageHeaderBase
  {
    [CCode (cname = "pos")]
    public unowned OS.Coord Pos;
    [CCode (cname = "buttons")]
    public unowned Wimp.MouseState Buttons;
    [CCode (cname = "w")]
    public unowned Wimp.W W;
    [CCode (cname = "i")]
    public unowned Wimp.I I;
  }

  [CCode (cname = "help_full_message_reply")]
  public struct FullMessageReply : Wimp.MessageHeaderBase
  {
    [CCode (cname = "reply")]
    public unowned char Reply[236];
  }

  [CCode (cname = "help_full_message_enable")]
  public struct FullMessageEnable : Wimp.MessageHeaderBase
  {
    [CCode (cname = "flags")]
    public unowned Flags Flags;
  }

  [CCode (cname="message_HELP_REQUEST")]
  public const bits Message_HelpRequest;
  [CCode (cname="message_HELP_REPLY")]
  public const bits Message_HelpReply;
  [CCode (cname="message_HELP_ENABLE")]
  public const bits Message_HelpEnable;

}
