/* OSLib---efficient, type-safe, transparent, extensible,
 * register-safe API coverage of RISC OS
 * 
 * Copyright (c) 1994-2012 Jonathan Coxhead and OSLib maintainers
 * 
 * Licence:
 * 
 *    OSLib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version - and this with the following clarification and
 * special exception:
 * 
 *    Linking this library statically or dynamically with other modules
 * is making a combined work based on this library. Thus, the terms
 * and conditions of the GNU General Public License cover the whole
 * combination.
 * 
 *    As a special exception, the copyright holders of this library
 * give you permission to link this library with independent modules
 * to produce an executable, regardless of the license terms of these
 * independent modules, and to copy and distribute the resulting
 * executable under terms of your choice, provided that you also meet,
 * for each linked independent module, the terms and conditions of the
 * license of that module. An independent module is a module which is
 * not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library,
 * but you are not obliged to do so. If you do not wish to do so, delete
 * this exception statement from your version.
 * 
 *    OSLib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License
 * along with this programme; if not, write to the Free Software
 * Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using OSLib;
using OSLib.OS;
using OSLib.Wimp;

[CCode (cheader_filename = "oslib/inetsuite.h")]
namespace OSLib.InetSuite
{
  [CCode (cname = "inetsuite_open_url_flags")]
  public enum OpenURLFlags
  {
    [CCode (cname = "inetsuite_USE_MIME_TYPE")]
    UseMIMEType
  }

  [CCode (cname = "inetsuite_message_open_url")]
  public struct MessageOpenURL
  {
    [CCode (cname = "url")]
    public unowned char Url[236];
    [CCode (cname = "indirect.tag")]
    public unowned int Indirect_Tag;
    [CCode (cname = "indirect.url")]
    public unowned OS.StringValue Indirect_Url;
    [CCode (cname = "indirect.flags")]
    public unowned OpenURLFlags Indirect_Flags;
    [CCode (cname = "indirect.body_file")]
    public unowned OS.StringValue Indirect_BodyFile;
    [CCode (cname = "indirect.target")]
    public unowned OS.StringValue Indirect_Target;
    [CCode (cname = "indirect.body_mimetype")]
    public unowned OS.StringValue Indirect_BodyMimetype;
  }

  [CCode (cname = "inetsuite_full_message_open_url_direct")]
  public struct FullMessageOpenURLDirect : Wimp.MessageHeaderBase
  {
    [CCode (cname = "url")]
    public unowned char Url[236];
  }

  [CCode (cname = "inetsuite_full_message_open_url_indirect")]
  public struct FullMessageOpenURLIndirect : Wimp.MessageHeaderBase
  {
    [CCode (cname = "tag")]
    public unowned int Tag;
    [CCode (cname = "url")]
    public unowned OS.StringValue Url;
    [CCode (cname = "flags")]
    public unowned OpenURLFlags Flags;
    [CCode (cname = "body_file")]
    public unowned OS.StringValue BodyFile;
    [CCode (cname = "target")]
    public unowned OS.StringValue Target;
    [CCode (cname = "body_mimetype")]
    public unowned OS.StringValue BodyMimetype;
  }

  [CCode (cname = "inetsuite_full_message_open_url")]
  public struct FullMessageOpenURL
  {
    [CCode (cname = "direct")]
    public unowned FullMessageOpenURLDirect Direct;
    [CCode (cname = "indirect")]
    public unowned FullMessageOpenURLIndirect Indirect;
  }

  [CCode (cname="message_INET_SUITE_OPEN_URL")]
  public const bits Message_InetSuiteOpenURL;

}
