/* OSLib---efficient, type-safe, transparent, extensible,
 * register-safe API coverage of RISC OS
 * 
 * Copyright (c) 1994-2012 Jonathan Coxhead and OSLib maintainers
 * 
 * Licence:
 * 
 *    OSLib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version - and this with the following clarification and
 * special exception:
 * 
 *    Linking this library statically or dynamically with other modules
 * is making a combined work based on this library. Thus, the terms
 * and conditions of the GNU General Public License cover the whole
 * combination.
 * 
 *    As a special exception, the copyright holders of this library
 * give you permission to link this library with independent modules
 * to produce an executable, regardless of the license terms of these
 * independent modules, and to copy and distribute the resulting
 * executable under terms of your choice, provided that you also meet,
 * for each linked independent module, the terms and conditions of the
 * license of that module. An independent module is a module which is
 * not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library,
 * but you are not obliged to do so. If you do not wish to do so, delete
 * this exception statement from your version.
 * 
 *    OSLib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License
 * along with this programme; if not, write to the Free Software
 * Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using OSLib;
using OSLib.OS;

[CCode (cheader_filename = "oslib/osreadsysinfo.h")]
namespace OSLib.OSReadSysInfo
{
  [CCode (cname = "osreadsysinfo_flags0")]
  public enum Flags0
  {
    [CCode (cname = "osreadsysinfo_SPECIAL_FUNCTION")]
    SpecialFunction,
    [CCode (cname = "osreadsysinfo_SPECIAL_FUNCTION_NONE")]
    SpecialFunctionNone,
    [CCode (cname = "osreadsysinfo_SPECIAL_FUNCTION_IOEB")]
    SpecialFunctionIOEB,
    [CCode (cname = "osreadsysinfo_IO_CONTROL")]
    IOControl,
    [CCode (cname = "osreadsysinfo_IO_CONTROL_IOC")]
    IOControlIOC,
    [CCode (cname = "osreadsysinfo_IO_CONTROL_IOMD")]
    IOControlIOMD,
    [CCode (cname = "osreadsysinfo_IO_CONTROL_UNDEFINED")]
    IOControlUndefined,
    [CCode (cname = "osreadsysinfo_MEMORY_CONTROL")]
    MemoryControl,
    [CCode (cname = "osreadsysinfo_MEMORY_CONTROL_MEMC1")]
    MemoryControlMEMC1,
    [CCode (cname = "osreadsysinfo_MEMORY_CONTROL_IOMD")]
    MemoryControlIOMD,
    [CCode (cname = "osreadsysinfo_MEMORY_CONTROL_UNDEFINED")]
    MemoryControlUndefined,
    [CCode (cname = "osreadsysinfo_VIDEO_CONTROL")]
    VideoControl,
    [CCode (cname = "osreadsysinfo_VIDEO_CONTROL_VIDC_1A")]
    VideoControlVIDC1a,
    [CCode (cname = "osreadsysinfo_VIDEO_CONTROL_VIDC20")]
    VideoControlVIDC20,
    [CCode (cname = "osreadsysinfo_VIDEO_CONTROL_UNDEFINED")]
    VideoControlUndefined
  }

  [CCode (cname = "osreadsysinfo_flags1")]
  public enum Flags1
  {
    [CCode (cname = "osreadsysinfo_IO")]
    IO,
    [CCode (cname = "osreadsysinfo_IO_NONE")]
    IONone,
    [CCode (cname = "osreadsysinfo_IO82C710")]
    IO82C710
  }

  [CCode (cname = "osreadsysinfo_flags2")]
  public enum Flags2
  {
    [CCode (cname = "osreadsysinfo_LCD_CONTROL")]
    LCDControl,
    [CCode (cname = "osreadsysinfo_LCD_CONTROL_NONE")]
    LCDControlNone,
    [CCode (cname = "osreadsysinfo_LCD_CONTROL_TYPE1")]
    LCDControlType1,
    [CCode (cname = "osreadsysinfo_LCD_CONTROL_TYPE2")]
    LCDControlType2,
    [CCode (cname = "osreadsysinfo_IOMD_TYPE")]
    IOMDType,
    [CCode (cname = "osreadsysinfo_IOMD_TYPE_IOMD")]
    IOMDTypeIOMD,
    [CCode (cname = "osreadsysinfo_IOMD_TYPE_IOMDL")]
    IOMDTypeIOMDL,
    [CCode (cname = "osreadsysinfo_IOMD_TYPE_NONE")]
    IOMDTypeNone,
    [CCode (cname = "osreadsysinfo_IIC2_HIGH_SPEED")]
    IIC2HighSpeed,
    [CCode (cname = "osreadsysinfo_IO_CLOCK_STATE_AT_IDLE")]
    IOClockStateAtIdle
  }

  [CCode (cname = "osreadsysinfo_platform")]
  public enum Platform
  {
    [CCode (cname = "osreadsysinfo_PLATFORM_UNKNOWN")]
    Unknown,
    [CCode (cname = "osreadsysinfo_PLATFORM_RISC_PC")]
    RiscPC,
    [CCode (cname = "osreadsysinfo_PLATFORM_A7000")]
    A7000,
    [CCode (cname = "osreadsysinfo_PLATFORM_A7000_PLUS")]
    A7000Plus,
    [CCode (cname = "osreadsysinfo_PLATFORM_PHOEBE")]
    Phoebe,
    [CCode (cname = "osreadsysinfo_PLATFORM_HAL")]
    HAL,
    [CCode (cname = "osreadsysinfo_PLATFORM_VIRTUAL_RPC")]
    VirtualRPC,
    [CCode (cname = "osreadsysinfo_PLATFORM_A9")]
    A9
  }

  [CCode (cname = "osreadsysinfo_platform_flags")]
  public enum PlatformFlags
  {
    [CCode (cname = "osreadsysinfo_PLATFORM_SUPPORTS_PODULES")]
    PlatformSupportsPodules,
    [CCode (cname = "osreadsysinfo_PLATFORM_SUPPORTS_PCI")]
    PlatformSupportsPCI,
    [CCode (cname = "osreadsysinfo_PLATFORM_SUPPORTS_MULTI_CPU")]
    PlatformSupportsMultiCPU,
    [CCode (cname = "osreadsysinfo_PLATFORM_HAS_SOFT_POWER_CONTROL")]
    PlatformHasSoftPowerControl,
    [CCode (cname = "osreadsysinfo_PLATFORM_RUNS_OS_FROM_RAM")]
    PlatformRunsOSFromRAM
  }

  [CCode (cname = "osreadsysinfo_kernel_value_id")]
  public enum KernelValueID
  {
    [CCode (cname = "osreadsysinfokernelvalueid_OS_PAGE_TABLE")]
    OSPageTable,
    [CCode (cname = "osreadsysinfokernelvalueid_HIGEST_OS_PAGE_TABLE_PTR")]
    HigestOSPageTablePtr,
    [CCode (cname = "osreadsysinfokernelvalueid_UNAVAILABLE_PAGES_PPL")]
    UnavailablePagesPPL,
    [CCode (cname = "osreadsysinfokernelvalueid_PHYS_MEM_TABLE")]
    PhysMemTable,
    [CCode (cname = "osreadsysinfokernelvalueid_CACHE_CLEANER_FLIP_FLOP")]
    CacheCleanerFlipFlop,
    [CCode (cname = "osreadsysinfokernelvalueid_INTERNAL_TICKER_CHAIN")]
    InternalTickerChain,
    [CCode (cname = "osreadsysinfokernelvalueid_ROM_MODUE_CHAIN")]
    ROMModueChain,
    [CCode (cname = "osreadsysinfokernelvalueid_DA_LIST")]
    DAList,
    [CCode (cname = "osreadsysinfokernelvalueid_DA_SPACE_NODE")]
    DASpaceNode,
    [CCode (cname = "osreadsysinfokernelvalueid_MODULE_CHAIN")]
    ModuleChain,
    [CCode (cname = "osreadsysinfokernelvalueid_SWI_HASH_TABLE_ENTRIES")]
    SWIHashTableEntries,
    [CCode (cname = "osreadsysinfokernelvalueid_SWI_HASH_TABLE")]
    SWIHashTable,
    [CCode (cname = "osreadsysinfokernelvalueid_IO_SYSTEM_TYPE_FLAGS")]
    IOSystemTypeFlags,
    [CCode (cname = "osreadsysinfokernelvalueid_L1_PAGE_TABLE")]
    L1PageTable,
    [CCode (cname = "osreadsysinfokernelvalueid_L2_PAGE_TABLE")]
    L2PageTable,
    [CCode (cname = "osreadsysinfokernelvalueid_TOP_UND_MODE_STACK")]
    TopUNDModeStack,
    [CCode (cname = "osreadsysinfokernelvalueid_TOP_SVC_MODE_STACK")]
    TopSVCModeStack,
    [CCode (cname = "osreadsysinfokernelvalueid_START_SYSTEM_HEAP")]
    StartSystemHeap,
    [CCode (cname = "osreadsysinfokernelvalueid_KERNEL_MSG_TRANS_BLOCK")]
    KernelMsgTransBlock,
    [CCode (cname = "osreadsysinfokernelvalueid_ERROR_SEMAPHORE")]
    ErrorSemaphore,
    [CCode (cname = "osreadsysinfokernelvalueid_PRETTY_PRINT_DICT")]
    PrettyPrintDict,
    [CCode (cname = "osreadsysinfokernelvalueid_TIMER0_LATCH_VALUE")]
    Timer0LatchValue,
    [CCode (cname = "osreadsysinfokernelvalueid_FAST_TICKER_VSPEED")]
    FastTickerVSpeed,
    [CCode (cname = "osreadsysinfokernelvalueid_VECTOR_CLAIMANTS_TABLE")]
    VectorClaimantsTable,
    [CCode (cname = "osreadsysinfokernelvalueid_NUM_VECTORS")]
    NumVectors,
    [CCode (cname = "osreadsysinfokernelvalueid_TOP_IRQ_MODE_STACK")]
    TopIRQModeStack,
    [CCode (cname = "osreadsysinfokernelvalueid_SWI_DISPATCH_TABLE")]
    SWIDispatchTable,
    [CCode (cname = "osreadsysinfokernelvalueid_BRANCH_AFTER_SWI")]
    BranchAfterSWI
  }

  [CCode (cname = "osreadsysinfo_rom_information_code")]
  public enum ROMInformationCode
  {
    [CCode (cname = "osreadsysinfo_OS_NAME")]
    OSName,
    [CCode (cname = "osreadsysinfo_PART_NUMBER")]
    PartNumber,
    [CCode (cname = "osreadsysinfo_BUILD_TIME")]
    BuildTime,
    [CCode (cname = "osreadsysinfo_DEALER_NAME")]
    DealerName,
    [CCode (cname = "osreadsysinfo_USER_NAME")]
    UserName,
    [CCode (cname = "osreadsysinfo_USER_ADDRESS")]
    UserAddress,
    [CCode (cname = "osreadsysinfo_OS_DESCRIPTION")]
    OSDescription
  }

  [CCode (cname="osreadsysinfo_SPECIAL_FUNCTION_SHIFT")]
  public const int SpecialFunctionShift;
  [CCode (cname="osreadsysinfo_IO_CONTROL_SHIFT")]
  public const int IOControlShift;
  [CCode (cname="osreadsysinfo_MEMORY_CONTROL_SHIFT")]
  public const int MemoryControlShift;
  [CCode (cname="osreadsysinfo_VIDEO_CONTROL_SHIFT")]
  public const int VideoControlShift;
  [CCode (cname="osreadsysinfo_IO_SHIFT")]
  public const int IOShift;
  [CCode (cname="osreadsysinfo_LCD_CONTROL_SHIFT")]
  public const int LCDControlShift;
  [CCode (cname="osreadsysinfo_IOMD_TYPE_SHIFT")]
  public const int IOMDTypeShift;

  [CCode (cname = "xosreadsysinfo_screen_size")]
  public static OS.Error* XScreenSize
    (out int screen_size);

  [CCode (cname = "osreadsysinfo_screen_size")]
  public static int ScreenSize ();

  [CCode (cname = "xosreadsysinfo_mode")]
  public static OS.Error* XMode
    (out OS.Mode mode,
     out int monitor_type,
     out int sync);

  [CCode (cname = "osreadsysinfo_mode")]
  public static OS.Mode Mode
    (out int monitor_type,
     out int sync);

  [CCode (cname = "xosreadsysinfo_machine_id")]
  public static OS.Error* XMachineId
    (out Flags0 config0,
     out Flags1 config1,
     out Flags2 config2,
     out bits id_lo,
     out bits id_hi);

  [CCode (cname = "osreadsysinfo_machine_id")]
  public static void MachineId
    (out Flags0 config0,
     out Flags1 config1,
     out Flags2 config2,
     out bits id_lo,
     out bits id_hi);

  [CCode (cname = "xosreadsysinfo_71x_features")]
  public static OS.Error* X71XFeatures
    (out bits features,
     out bits features_extended0,
     out bits features_extended1,
     out bits features_extended2,
     out bits features_extended3);

  [CCode (cname = "osreadsysinfo_71x_features")]
  public static void 71XFeatures
    (out bits features,
     out bits features_extended0,
     out bits features_extended1,
     out bits features_extended2,
     out bits features_extended3);

  [CCode (cname = "xosreadsysinfo_ethernet_address")]
  public static OS.Error* XEthernetAddress
    (out bits address_lo,
     out bits address_hi);

  [CCode (cname = "osreadsysinfo_ethernet_address")]
  public static void EthernetAddress
    (out bits address_lo,
     out bits address_hi);

  [CCode (cname = "xosreadsysinfo_raw_machine_id")]
  public static OS.Error* XRawMachineId
    (out bits id_lo,
     out bits id_hi);

  [CCode (cname = "osreadsysinfo_raw_machine_id")]
  public static void RawMachineId
    (out bits id_lo,
     out bits id_hi);

  [CCode (cname = "xosreadsysinfo_kernel_value")]
  public static OS.Error* XKernelValue
    (KernelValueID item,
     out int value);

  [CCode (cname = "osreadsysinfo_kernel_value")]
  public static int KernelValue
    (KernelValueID item);

  [CCode (cname = "xosreadsysinfo_kernel_values")]
  public static OS.Error* XKernelValues
    (int* item_list,
     KernelValueID value_buffer);

  [CCode (cname = "osreadsysinfo_kernel_values")]
  public static void KernelValues
    (int* item_list,
     KernelValueID value_buffer);

  [CCode (cname = "xosreadsysinfokernelvalue_svcstk")]
  public static OS.Error* XOSReadSysInfoKernelValue_SVCSTK
    (out char* stack_top);

  [CCode (cname = "osreadsysinfokernelvalue_svcstk")]
  public static char* OSReadSysInfoKernelValue_SVCSTK ();

  [CCode (cname = "xosreadsysinfokernelvalue_swi_dispatch_table")]
  public static OS.Error* XOSReadSysInfoKernelValue_SWIDispatchTable
    (out char* dispatch_table);

  [CCode (cname = "osreadsysinfokernelvalue_swi_dispatch_table")]
  public static char* OSReadSysInfoKernelValue_SWIDispatchTable ();

  [CCode (cname = "xosreadsysinfo_last_abort_info")]
  public static OS.Error* XLastAbortInfo
    (out char* abort_pc,
     out char* abort_psr,
     out char* fault_address);

  [CCode (cname = "osreadsysinfo_last_abort_info")]
  public static char* LastAbortInfo
    (out char* abort_pc,
     out char* abort_psr);

  [CCode (cname = "xosreadsysinfo_platform_class")]
  public static OS.Error* XPlatformClass
    (out Platform platform_class,
     out PlatformFlags flags,
     out PlatformFlags valid_flags);

  [CCode (cname = "osreadsysinfo_platform_class")]
  public static Platform PlatformClass
    (out PlatformFlags flags,
     out PlatformFlags valid_flags);

  [CCode (cname = "xosreadsysinfo_rom_information")]
  public static OS.Error* XROMInformation
    (ROMInformationCode code,
     out string information);

  [CCode (cname = "osreadsysinfo_rom_information")]
  public static string ROMInformation
    (ROMInformationCode code);

  [CCode (cname = "xosreadsysinfo_read_os_version")]
  public static OS.Error* XReadOSVersion
    (out int os_version,
     out int kernel_version,
     out int sysinit_version_and_type);

  [CCode (cname = "osreadsysinfo_read_os_version")]
  public static int ReadOSVersion
    (out int kernel_version,
     out int sysinit_version_and_type);

  [CCode (cname = "xosreadsysinfo_read_debug_info")]
  public static OS.Error* XReadDebugInfo
    (out AsmRoutine write_dbg,
     out AsmRoutine read_dbg);

  [CCode (cname = "osreadsysinfo_read_debug_info")]
  public static void ReadDebugInfo
    (out AsmRoutine write_dbg,
     out AsmRoutine read_dbg);

}
