/* OSLib---efficient, type-safe, transparent, extensible,
 * register-safe API coverage of RISC OS
 * 
 * Copyright (c) 1994-2012 Jonathan Coxhead and OSLib maintainers
 * 
 * Licence:
 * 
 *    OSLib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version - and this with the following clarification and
 * special exception:
 * 
 *    Linking this library statically or dynamically with other modules
 * is making a combined work based on this library. Thus, the terms
 * and conditions of the GNU General Public License cover the whole
 * combination.
 * 
 *    As a special exception, the copyright holders of this library
 * give you permission to link this library with independent modules
 * to produce an executable, regardless of the license terms of these
 * independent modules, and to copy and distribute the resulting
 * executable under terms of your choice, provided that you also meet,
 * for each linked independent module, the terms and conditions of the
 * license of that module. An independent module is a module which is
 * not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library,
 * but you are not obliged to do so. If you do not wish to do so, delete
 * this exception statement from your version.
 * 
 *    OSLib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License
 * along with this programme; if not, write to the Free Software
 * Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using OSLib;
using OSLib.Toolbox;
using OSLib.Gadget;

[CCode (cheader_filename = "oslib/popup.h")]
namespace OSLib.PopUp
{
  [CCode (cname = "popup_gadget")]
  public struct Gadget
  {
    [CCode (cname = "menu_name")]
    public unowned Toolbox.StringReference MenuName;
  }

  [CCode (cname = "popup_object")]
  public struct Object : OSLib.Gadget.ObjectBase
  {
    [CCode (cname = "menu_name")]
    public unowned Toolbox.StringReference MenuName;
  }

  [CCode (cname = "popup_full")]
  public enum Full
  {
    Default = 0
  }

  [CCode (cname = "popup_action_about_to_be_shown")]
  public struct ActionAboutToBeShown
  {
    [CCode (cname = "menu")]
    public unowned Toolbox.O Menu;
  }

  [CCode (cname = "popup_action_about_to_be_shown_block")]
  public struct ActionAboutToBeShownBlock : Toolbox.ActionHeaderBase
  {
    [CCode (cname = "menu")]
    public unowned Toolbox.O Menu;
  }

  [CCode (cname="class_POP_UP")]
  public const Toolbox.Class Class_PopUp;
  [CCode (cname="popup_GENERATE_ABOUT_TO_BE_SHOWN")]
  public const OSLib.Gadget.Flags GenerateAboutToBeShown;
  [CCode (cname="action_POP_UP_ABOUT_TO_BE_SHOWN")]
  public const bits Action_PopUpAboutToBeShown;

  [CCode (cname = "xpopup_set_menu")]
  public static OS.Error* XSetMenu
    (bits flags,
     Toolbox.O window,
     Toolbox.C popup,
     Toolbox.O menu);

  [CCode (cname = "popup_set_menu")]
  public static void SetMenu
    (bits flags,
     Toolbox.O window,
     Toolbox.C popup,
     Toolbox.O menu);

  [CCode (cname = "xpopup_get_menu")]
  public static OS.Error* XGetMenu
    (bits flags,
     Toolbox.O window,
     Toolbox.C popup,
     out Toolbox.O menu);

  [CCode (cname = "popup_get_menu")]
  public static Toolbox.O GetMenu
    (bits flags,
     Toolbox.O window,
     Toolbox.C popup);

}
