/* OSLib---efficient, type-safe, transparent, extensible,
 * register-safe API coverage of RISC OS
 * 
 * Copyright (c) 1994-2012 Jonathan Coxhead and OSLib maintainers
 * 
 * Licence:
 * 
 *    OSLib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version - and this with the following clarification and
 * special exception:
 * 
 *    Linking this library statically or dynamically with other modules
 * is making a combined work based on this library. Thus, the terms
 * and conditions of the GNU General Public License cover the whole
 * combination.
 * 
 *    As a special exception, the copyright holders of this library
 * give you permission to link this library with independent modules
 * to produce an executable, regardless of the license terms of these
 * independent modules, and to copy and distribute the resulting
 * executable under terms of your choice, provided that you also meet,
 * for each linked independent module, the terms and conditions of the
 * license of that module. An independent module is a module which is
 * not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library,
 * but you are not obliged to do so. If you do not wish to do so, delete
 * this exception statement from your version.
 * 
 *    OSLib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License
 * along with this programme; if not, write to the Free Software
 * Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using OSLib;
using OSLib.OS;
using OSLib.Wimp;

[CCode (cheader_filename = "oslib/redrawmanager.h")]
namespace OSLib.RedrawManager
{
  [CCode (cname = "redrawaddremovecallback_flags")]
  public enum RedrawAddRemoveCallBack_Flags
  {
    [CCode (cname = "redrawaddremovecallbackflags_SETUP_GRAPH_RECT")]
    SetupGraphRect,
    [CCode (cname = "redrawaddremovecallbackflags_SCREEN_COORDS")]
    ScreenCoords,
    [CCode (cname = "redrawaddremovecallbackflags_AFTER_ICON_PLOT")]
    AfterIconPlot
  }


  [CCode (cname = "xredrawaddcallback_swi")]
  public static OS.Error* XRedrawAddCallBack_SWI
    (RedrawAddRemoveCallBack_Flags flags,
     Wimp.W window_handle,
     int swi,
     OS.Box region,
     int region_data);

  [CCode (cname = "redrawaddcallback_swi")]
  public static void RedrawAddCallBack_SWI
    (RedrawAddRemoveCallBack_Flags flags,
     Wimp.W window_handle,
     int swi,
     OS.Box region,
     int region_data);

  [CCode (cname = "xredrawaddcallback_address")]
  public static OS.Error* XRedrawAddCallBack_Address
    (RedrawAddRemoveCallBack_Flags flags,
     Wimp.W window_handle,
     AsmRoutine callback,
     OS.Box region,
     int region_data,
     int private_word);

  [CCode (cname = "redrawaddcallback_address")]
  public static void RedrawAddCallBack_Address
    (RedrawAddRemoveCallBack_Flags flags,
     Wimp.W window_handle,
     AsmRoutine callback,
     OS.Box region,
     int region_data,
     int private_word);

  [CCode (cname = "xredrawremovecallback_swi")]
  public static OS.Error* XRedrawRemoveCallBack_SWI
    (RedrawAddRemoveCallBack_Flags flags,
     Wimp.W window_handle,
     int swi,
     OS.Box region,
     int region_data);

  [CCode (cname = "redrawremovecallback_swi")]
  public static void RedrawRemoveCallBack_SWI
    (RedrawAddRemoveCallBack_Flags flags,
     Wimp.W window_handle,
     int swi,
     OS.Box region,
     int region_data);

  [CCode (cname = "xredrawremovecallback_address")]
  public static OS.Error* XRedrawRemoveCallBack_Address
    (RedrawAddRemoveCallBack_Flags flags,
     Wimp.W window_handle,
     AsmRoutine callback,
     OS.Box region,
     int region_data,
     int private_word);

  [CCode (cname = "redrawremovecallback_address")]
  public static void RedrawRemoveCallBack_Address
    (RedrawAddRemoveCallBack_Flags flags,
     Wimp.W window_handle,
     AsmRoutine callback,
     OS.Box region,
     int region_data,
     int private_word);

  [CCode (cname = "xservice_redraw_manager_installed")]
  public static OS.Error* XService_RedrawManagerInstalled
    (int version);

  [CCode (cname = "service_redraw_manager_installed")]
  public static void Service_RedrawManagerInstalled
    (int version);

  [CCode (cname = "xservice_redraw_manager_dying")]
  public static OS.Error* XService_RedrawManagerDying ();

  [CCode (cname = "service_redraw_manager_dying")]
  public static void Service_RedrawManagerDying ();

}
