/* OSLib---efficient, type-safe, transparent, extensible,
 * register-safe API coverage of RISC OS
 * 
 * Copyright (c) 1994-2012 Jonathan Coxhead and OSLib maintainers
 * 
 * Licence:
 * 
 *    OSLib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version - and this with the following clarification and
 * special exception:
 * 
 *    Linking this library statically or dynamically with other modules
 * is making a combined work based on this library. Thus, the terms
 * and conditions of the GNU General Public License cover the whole
 * combination.
 * 
 *    As a special exception, the copyright holders of this library
 * give you permission to link this library with independent modules
 * to produce an executable, regardless of the license terms of these
 * independent modules, and to copy and distribute the resulting
 * executable under terms of your choice, provided that you also meet,
 * for each linked independent module, the terms and conditions of the
 * license of that module. An independent module is a module which is
 * not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library,
 * but you are not obliged to do so. If you do not wish to do so, delete
 * this exception statement from your version.
 * 
 *    OSLib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License
 * along with this programme; if not, write to the Free Software
 * Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using OSLib;
using OSLib.OS;

[CCode (cheader_filename = "oslib/syslog.h")]
namespace OSLib.SysLog
{

  [CCode (cname = "xsyslog_log_message")]
  public static OS.Error* XLogMessage
    (char* name_or_handle,
     char* message,
     int priority);

  [CCode (cname = "syslog_log_message")]
  public static void LogMessage
    (char* name_or_handle,
     char* message,
     int priority);

  [CCode (cname = "xsyslog_log_message_by_handle")]
  public static OS.Error* XLogMessageByHandle
    (bits handle,
     char* message,
     int priority);

  [CCode (cname = "syslog_log_message_by_handle")]
  public static void LogMessageByHandle
    (bits handle,
     char* message,
     int priority);

  [CCode (cname = "xsyslog_get_log_level")]
  public static OS.Error* XGetLogLevel
    (char* name_or_handle,
     out int priority);

  [CCode (cname = "syslog_get_log_level")]
  public static int GetLogLevel
    (char* name_or_handle);

  [CCode (cname = "xsyslog_get_log_level_by_handle")]
  public static OS.Error* XGetLogLevelByHandle
    (bits handle,
     out int priority);

  [CCode (cname = "syslog_get_log_level_by_handle")]
  public static int GetLogLevelByHandle
    (bits handle);

  [CCode (cname = "xsyslog_flush_log")]
  public static OS.Error* XFlushLog
    (char* name_or_handle);

  [CCode (cname = "syslog_flush_log")]
  public static void FlushLog
    (char* name_or_handle);

  [CCode (cname = "xsyslog_flush_log_by_handle")]
  public static OS.Error* XFlushLogByHandle
    (bits handle);

  [CCode (cname = "syslog_flush_log_by_handle")]
  public static void FlushLogByHandle
    (bits handle);

  [CCode (cname = "xsyslog_set_log_level")]
  public static OS.Error* XSetLogLevel
    (char* name_or_handle,
     int priority);

  [CCode (cname = "syslog_set_log_level")]
  public static void SetLogLevel
    (char* name_or_handle,
     int priority);

  [CCode (cname = "xsyslog_set_log_level_by_handle")]
  public static OS.Error* XSetLogLevelByHandle
    (bits handle,
     int priority);

  [CCode (cname = "syslog_set_log_level_by_handle")]
  public static void SetLogLevelByHandle
    (bits handle,
     int priority);

  [CCode (cname = "xsyslog_log_unstamped")]
  public static OS.Error* XLogUnstamped
    (char* name_or_handle,
     char* message,
     int priority);

  [CCode (cname = "syslog_log_unstamped")]
  public static void LogUnstamped
    (char* name_or_handle,
     char* message,
     int priority);

  [CCode (cname = "xsyslog_log_unstamped_by_handle")]
  public static OS.Error* XLogUnstampedByHandle
    (bits handle,
     char* message,
     int priority);

  [CCode (cname = "syslog_log_unstamped_by_handle")]
  public static void LogUnstampedByHandle
    (bits handle,
     char* message,
     int priority);

  [CCode (cname = "xsyslog_indent")]
  public static OS.Error* XIndent
    (char* name_or_handle);

  [CCode (cname = "syslog_indent")]
  public static void Indent
    (char* name_or_handle);

  [CCode (cname = "xsyslog_indent_by_handle")]
  public static OS.Error* XIndentByHandle
    (bits handle);

  [CCode (cname = "syslog_indent_by_handle")]
  public static void IndentByHandle
    (bits handle);

  [CCode (cname = "xsyslog_un_indent")]
  public static OS.Error* XUnIndent
    (char* name_or_handle);

  [CCode (cname = "syslog_un_indent")]
  public static void UnIndent
    (char* name_or_handle);

  [CCode (cname = "xsyslog_un_indent_by_handle")]
  public static OS.Error* XUnIndentByHandle
    (bits handle);

  [CCode (cname = "syslog_un_indent_by_handle")]
  public static void UnIndentByHandle
    (bits handle);

  [CCode (cname = "xsyslog_no_indent")]
  public static OS.Error* XNoIndent
    (char* handle);

  [CCode (cname = "syslog_no_indent")]
  public static void NoIndent
    (char* handle);

  [CCode (cname = "xsyslog_no_indent_by_handle")]
  public static OS.Error* XNoIndentByHandle
    (bits handle);

  [CCode (cname = "syslog_no_indent_by_handle")]
  public static void NoIndentByHandle
    (bits handle);

  [CCode (cname = "xsyslog_open_session_log")]
  public static OS.Error* XOpenSessionLog
    (char* name,
     int priority,
     out char* handle);

  [CCode (cname = "syslog_open_session_log")]
  public static char OpenSessionLog
    (char* name,
     int priority);

  [CCode (cname = "xsyslog_open_session_log_by_handle")]
  public static OS.Error* XOpenSessionLogByHandle
    (char* name,
     int priority,
     out bits handle);

  [CCode (cname = "syslog_open_session_log_by_handle")]
  public static bits OpenSessionLogByHandle
    (char* name,
     int priority);

  [CCode (cname = "xsyslog_close_session_log")]
  public static OS.Error* XCloseSessionLog
    (char* handle);

  [CCode (cname = "syslog_close_session_log")]
  public static void CloseSessionLog
    (char* handle);

  [CCode (cname = "xsyslog_close_session_log_by_handle")]
  public static OS.Error* XCloseSessionLogByHandle
    (bits handle);

  [CCode (cname = "syslog_close_session_log_by_handle")]
  public static void CloseSessionLogByHandle
    (bits handle);

  [CCode (cname = "xsyslog_log_data")]
  public static OS.Error* XLogData
    (char* name_or_handle,
     int priority,
     char* data,
     int data_size,
     char* base_address);

  [CCode (cname = "syslog_log_data")]
  public static void LogData
    (char* name_or_handle,
     int priority,
     char* data,
     int data_size,
     char* base_address);

  [CCode (cname = "xsyslog_log_data_by_handle")]
  public static OS.Error* XLogDataByHandle
    (bits handle,
     int priority,
     char* data,
     int data_size,
     char* base_address);

  [CCode (cname = "syslog_log_data_by_handle")]
  public static void LogDataByHandle
    (bits handle,
     int priority,
     char* data,
     int data_size,
     char* base_address);

  [CCode (cname = "xsyslog_read_error_message")]
  public static OS.Error* XReadErrorMessage
    (int error_number,
     out char* error_message);

  [CCode (cname = "syslog_read_error_message")]
  public static char ReadErrorMessage
    (int error_number);

  [CCode (cname = "xsyslog_log_complete")]
  public static OS.Error* XLogComplete
    (char* name_or_handle);

  [CCode (cname = "syslog_log_complete")]
  public static void LogComplete
    (char* name_or_handle);

  [CCode (cname = "xsyslog_log_complete_by_handle")]
  public static OS.Error* XLogCompleteByHandle
    (bits handle);

  [CCode (cname = "syslog_log_complete_by_handle")]
  public static void LogCompleteByHandle
    (bits handle);

  [CCode (cname = "xsyslog_irq_mode")]
  public static OS.Error* XIRQMode
    (bool flag);

  [CCode (cname = "syslog_irq_mode")]
  public static void IRQMode
    (bool flag);

}
