/* OSLib---efficient, type-safe, transparent, extensible,
 * register-safe API coverage of RISC OS
 * 
 * Copyright (c) 1994-2012 Jonathan Coxhead and OSLib maintainers
 * 
 * Licence:
 * 
 *    OSLib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version - and this with the following clarification and
 * special exception:
 * 
 *    Linking this library statically or dynamically with other modules
 * is making a combined work based on this library. Thus, the terms
 * and conditions of the GNU General Public License cover the whole
 * combination.
 * 
 *    As a special exception, the copyright holders of this library
 * give you permission to link this library with independent modules
 * to produce an executable, regardless of the license terms of these
 * independent modules, and to copy and distribute the resulting
 * executable under terms of your choice, provided that you also meet,
 * for each linked independent module, the terms and conditions of the
 * license of that module. An independent module is a module which is
 * not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library,
 * but you are not obliged to do so. If you do not wish to do so, delete
 * this exception statement from your version.
 * 
 *    OSLib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License
 * along with this programme; if not, write to the Free Software
 * Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using OSLib;
using OSLib.OS;
using OSLib.OSSpriteOp;
using OSLib.Wimp;

[CCode (cheader_filename = "oslib/wimpextend.h")]
namespace OSLib.WimpExtend
{
  [CCode (cname = "wimpextend_furniture_sizes")]
  public struct FurnitureSizes
  {
    [CCode (cname = "w")]
    public unowned Wimp.W W;
    [CCode (cname = "border_widths")]
    public unowned OS.Box BorderWidths;
    [CCode (cname = "back_width")]
    public unowned int BackWidth;
    [CCode (cname = "close_width")]
    public unowned int CloseWidth;
    [CCode (cname = "reserved1")]
    public unowned int Reserved1;
    [CCode (cname = "title_width")]
    public unowned int TitleWidth;
    [CCode (cname = "reserved2")]
    public unowned int Reserved2;
    [CCode (cname = "iconise_width")]
    public unowned int IconiseWidth;
    [CCode (cname = "toggle_size_width")]
    public unowned int ToggleSizeWidth;
    [CCode (cname = "toggle_size_height")]
    public unowned int ToggleSizeHeight;
    [CCode (cname = "vertical_scroll_upper_gap")]
    public unowned int VerticalScrollUpperGap;
    [CCode (cname = "up_arrow_height")]
    public unowned int UpArrowHeight;
    [CCode (cname = "vertical_scroll_well_height")]
    public unowned int VerticalScrollWellHeight;
    [CCode (cname = "down_arrow_height")]
    public unowned int DownArrowHeight;
    [CCode (cname = "vertical_scroll_lower_gap")]
    public unowned int VerticalScrollLowerGap;
    [CCode (cname = "adjust_size_height")]
    public unowned int AdjustSizeHeight;
    [CCode (cname = "adjust_size_width")]
    public unowned int AdjustSizeWidth;
    [CCode (cname = "horizontal_scroll_right_gap")]
    public unowned int HorizontalScrollRightGap;
    [CCode (cname = "right_arrow_width")]
    public unowned int RightArrowWidth;
    [CCode (cname = "horizontal_scroll_well_width")]
    public unowned int HorizontalScrollWellWidth;
    [CCode (cname = "left_arrow_width")]
    public unowned int LeftArrowWidth;
    [CCode (cname = "horizontal_scroll_left_gap")]
    public unowned int HorizontalScrollLeftGap;
  }

  [CCode (cname = "wimpextendgetspritecolourmap_flags")]
  public enum WimpExtendGetSpriteColourMap_Flags
  {
    [CCode (cname = "wimpextendgetspritecolourmapflags_SELECTED_ITEM")]
    SelectedItem,
    [CCode (cname = "wimpextendgetspritecolourmapflags_FADED_ITEM")]
    FadedItem,
    [CCode (cname = "wimpextendgetspritecolourmapflags_PTR_OVER")]
    PtrOver
  }

  [CCode (cname="wimpextendgetspritecolourmapflags_FG_COLOUR_SHIFT")]
  public const int WimpExtendGetSpriteColourMapFlags_FGColourShift;
  [CCode (cname="wimpextendgetspritecolourmapflags_BG_COLOUR_SHIFT")]
  public const int WimpExtendGetSpriteColourMapFlags_BGColourShift;

  [CCode (cname = "xwimpextend_get_parent")]
  public static OS.Error* XGetParent
    (Wimp.W w,
     out Wimp.W parent);

  [CCode (cname = "wimpextend_get_parent")]
  public static Wimp.W GetParent
    (Wimp.W w);

  [CCode (cname = "xwimpextend_get_front_child")]
  public static OS.Error* XGetFrontChild
    (Wimp.W w,
     out Wimp.W child);

  [CCode (cname = "wimpextend_get_front_child")]
  public static Wimp.W GetFrontChild
    (Wimp.W w);

  [CCode (cname = "xwimpextend_get_back_child")]
  public static OS.Error* XGetBackChild
    (Wimp.W w,
     out Wimp.W child);

  [CCode (cname = "wimpextend_get_back_child")]
  public static Wimp.W GetBackChild
    (Wimp.W w);

  [CCode (cname = "xwimpextend_get_sibling_under")]
  public static OS.Error* XGetSiblingUnder
    (Wimp.W w,
     out Wimp.W sibling);

  [CCode (cname = "wimpextend_get_sibling_under")]
  public static Wimp.W GetSiblingUnder
    (Wimp.W w);

  [CCode (cname = "xwimpextend_get_sibling_over")]
  public static OS.Error* XGetSiblingOver
    (Wimp.W w,
     out Wimp.W sibling);

  [CCode (cname = "wimpextend_get_sibling_over")]
  public static Wimp.W GetSiblingOver
    (Wimp.W w);

  [CCode (cname = "xwimpextend_get_furniture_sizes")]
  public static OS.Error* XGetFurnitureSizes
    (FurnitureSizes sizes);

  [CCode (cname = "wimpextend_get_furniture_sizes")]
  public static void GetFurnitureSizes
    (FurnitureSizes sizes);

  [CCode (cname = "xwimpextend_get_sprite_address")]
  public static OS.Error* XGetSpriteAddress
    (OSSpriteOp.Area sprite_area,
     char* sprite_name,
     out OSSpriteOp.Area area,
     out OSSpriteOp.Header sprite);

  [CCode (cname = "wimpextend_get_sprite_address")]
  public static void GetSpriteAddress
    (OSSpriteOp.Area sprite_area,
     char* sprite_name,
     out OSSpriteOp.Area area,
     out OSSpriteOp.Header sprite);

  [CCode (cname = "xwimpextend_get_mode_suffix")]
  public static OS.Error* XGetModeSuffix
    (string filename,
     out string buffer1,
     out string buffer2);

  [CCode (cname = "wimpextend_get_mode_suffix")]
  public static void GetModeSuffix
    (string filename,
     out string buffer1,
     out string buffer2);

  [CCode (cname = "xwimpextend_get_sprite_colour_map")]
  public static OS.Error* XGetSpriteColourMap
    (WimpExtendGetSpriteColourMap_Flags flags,
     Wimp.W w,
     string validation,
     OS.Colour background,
     out OSSpriteOp.ColourMapping colourmap);

  [CCode (cname = "wimpextend_get_sprite_colour_map")]
  public static void GetSpriteColourMap
    (WimpExtendGetSpriteColourMap_Flags flags,
     Wimp.W w,
     string validation,
     OS.Colour background,
     out OSSpriteOp.ColourMapping colourmap);

}
